From fc2b1dc1a8f36e89c06e45ba6202887516e39ff5 Mon Sep 17 00:00:00 2001
From: Endi Sukma Dewata <edewata@redhat.com>
Date: Thu, 8 Nov 2012 21:35:25 -0500
Subject: [PATCH] Renamed pki-common-theme to pki-server-theme.

The Dogtag and IPA pki-common-theme packages have been renamed to
pki-server-theme.

Ticket #405
---
 scripts/build_dogtag_pki    |  4 ++--
 specs/dogtag-pki-theme.spec | 37 +++++++++++++++++++++++++------------
 specs/dogtag-pki.spec       |  7 +++++--
 specs/ipa-pki-theme.spec    | 25 +++++++++++++++++--------
 specs/pki-core.spec         |  7 +++++--
 5 files changed, 54 insertions(+), 26 deletions(-)

diff --git a/scripts/build_dogtag_pki b/scripts/build_dogtag_pki
index e360157121b94a6702b6975e225554f9df0feef6..5a63a692fdaf46bfbde46c9a40fe6e6663b86614 100755
--- a/scripts/build_dogtag_pki
+++ b/scripts/build_dogtag_pki
@@ -117,7 +117,7 @@ PKI_TPS_PACKAGES_DIR="${PKI_PWD}/packages.tps"
 PKI_CONSOLE_PACKAGES_DIR="${PKI_PWD}/packages.console"
 
 # Establish PKI theme package names
-PKI_COMMON_THEME=${PKI_FLAVOR}-pki-common-theme${RPM_EXT}
+PKI_SERVER_THEME=${PKI_FLAVOR}-pki-server-theme${RPM_EXT}
 PKI_CA_THEME=${PKI_FLAVOR}-pki-ca-theme${RPM_EXT}
 PKI_KRA_THEME=${PKI_FLAVOR}-pki-kra-theme${RPM_EXT}
 PKI_OCSP_THEME=${PKI_FLAVOR}-pki-ocsp-theme${RPM_EXT}
@@ -160,7 +160,7 @@ cd ${PKI_PWD}
 ${PKI_COMPOSE_SCRIPTS_DIR}/${COMPOSE_DOGTAG_PKI_THEME_PACKAGES} rpms
 mv ${PKI_PACKAGES_DIR} ${PKI_DOGTAG_THEME_PACKAGES_DIR}
 cd ${PKI_DOGTAG_THEME_PACKAGES_DIR}/${RPM_DIR}/${NOARCH}
-${PKI_SUDO} ${YUM_EXE} ${YUM_EXE_OPTIONS} ${PKI_COMMON_THEME} ${PKI_CA_THEME} ${PKI_KRA_THEME} ${PKI_OCSP_THEME} ${PKI_RA_THEME} ${PKI_TKS_THEME} ${PKI_TPS_THEME} ${PKI_CONSOLE_THEME}
+${PKI_SUDO} ${YUM_EXE} ${YUM_EXE_OPTIONS} ${PKI_SERVER_THEME} ${PKI_CA_THEME} ${PKI_KRA_THEME} ${PKI_OCSP_THEME} ${PKI_RA_THEME} ${PKI_TKS_THEME} ${PKI_TPS_THEME} ${PKI_CONSOLE_THEME}
 
 # Compose and install 'pki-core' packages
 cd ${PKI_PWD}
diff --git a/specs/dogtag-pki-theme.spec b/specs/dogtag-pki-theme.spec
index deb9aa8453dd8b0e1bba799d6fc6aa55e8c1fbbd..ac4384ef7fd1f6945df24a5dc9063e6e8382294e 100644
--- a/specs/dogtag-pki-theme.spec
+++ b/specs/dogtag-pki-theme.spec
@@ -7,7 +7,7 @@
 
 Name:             dogtag-pki-theme
 Version:          10.0.0
-Release:          %{?relprefix}4%{?prerel}%{?dist}
+Release:          %{?relprefix}5%{?prerel}%{?dist}
 Summary:          Certificate System - Dogtag PKI Theme Components
 URL:              http://pki.fedoraproject.org/
 License:          GPLv2
@@ -58,28 +58,33 @@ for its corresponding "ipa" theme package or "dogtag" theme package.   \
 %description %{overview}
 
 
-%package -n       dogtag-pki-common-theme
-Summary:          Certificate System - PKI Common Framework User Interface
+%package -n       dogtag-pki-server-theme
+Summary:          Certificate System - PKI Server Framework User Interface
 Group:            System Environment/Base
 
 %if 0%{?rhel}
 # EPEL version of Dogtag "theme" conflicts with all versions of Red Hat "theme"
+Conflicts:        redhat-pki-server-theme
 Conflicts:        redhat-pki-common-theme
 Conflicts:        redhat-pki-common-ui
 
 # EPEL version of Dogtag "theme" ALWAYS replaces ALL versions of IPA "theme"
+Obsoletes:        ipa-pki-server-theme <= 9999
 Obsoletes:        ipa-pki-common-theme <= 9999
+Provides:         ipa-pki-server-theme = %{version}-%{release}
 Provides:         ipa-pki-common-theme = %{version}-%{release}
 %endif
 
-Obsoletes:        dogtag-pki-common-ui <= 9
+Obsoletes:        dogtag-pki-common-theme
+Obsoletes:        dogtag-pki-common-ui
 
+Provides:         pki-server-theme = %{version}-%{release}
 Provides:         pki-common-theme = %{version}-%{release}
 Provides:         pki-common-ui = %{version}-%{release}
 
-%description -n   dogtag-pki-common-theme
-This PKI Common Framework User Interface contains
-the Dogtag textual and graphical user interface for the PKI Common Framework.
+%description -n   dogtag-pki-server-theme
+This PKI Server Framework User Interface contains
+the Dogtag textual and graphical user interface for the PKI Server Framework.
 
 This package is used by the Dogtag Certificate System.
 
@@ -90,7 +95,7 @@ This package is used by the Dogtag Certificate System.
 Summary:          Certificate System - Certificate Authority User Interface
 Group:            System Environment/Base
 
-Requires:         dogtag-pki-common-theme = %{version}-%{release}
+Requires:         dogtag-pki-server-theme = %{version}-%{release}
 
 %if 0%{?rhel}
 # EPEL version of Dogtag "theme" conflicts with all versions of Red Hat "theme"
@@ -120,7 +125,7 @@ This package is used by the Dogtag Certificate System.
 Summary:          Certificate System - Data Recovery Manager User Interface
 Group:            System Environment/Base
 
-Requires:         dogtag-pki-common-theme = %{version}-%{release}
+Requires:         dogtag-pki-server-theme = %{version}-%{release}
 
 %if 0%{?rhel}
 # EPEL version of Dogtag "theme" conflicts with all versions of Red Hat "theme"
@@ -146,7 +151,7 @@ This package is used by the Dogtag Certificate System.
 Summary:          Certificate System - Online Certificate Status Protocol Manager User Interface
 Group:            System Environment/Base
 
-Requires:         dogtag-pki-common-theme = %{version}-%{release}
+Requires:         dogtag-pki-server-theme = %{version}-%{release}
 
 %if 0%{?rhel}
 # EPEL version of Dogtag "theme" conflicts with all versions of Red Hat "theme"
@@ -172,6 +177,8 @@ This package is used by the Dogtag Certificate System.
 Summary:          Certificate System - Registration Authority User Interface
 Group:            System Environment/Base
 
+Requires:         dogtag-pki-server-theme = %{version}-%{release}
+
 %if 0%{?rhel}
 # EPEL version of Dogtag "theme" conflicts with all versions of Red Hat "theme"
 Conflicts:        redhat-pki-ra-theme
@@ -196,7 +203,7 @@ This package is used by the Dogtag Certificate System.
 Summary:          Certificate System - Token Key Service User Interface
 Group:            System Environment/Base
 
-Requires:         dogtag-pki-common-theme = %{version}-%{release}
+Requires:         dogtag-pki-server-theme = %{version}-%{release}
 
 %if 0%{?rhel}
 # EPEL version of Dogtag "theme" conflicts with all versions of Red Hat "theme"
@@ -222,6 +229,8 @@ This package is used by the Dogtag Certificate System.
 Summary:          Certificate System - Token Processing System User Interface
 Group:            System Environment/Base
 
+Requires:         dogtag-pki-server-theme = %{version}-%{release}
+
 %if 0%{?rhel}
 # EPEL version of Dogtag "theme" conflicts with all versions of Red Hat "theme"
 Conflicts:        redhat-pki-tps-theme
@@ -309,7 +318,7 @@ chmod 755 %{buildroot}%{_datadir}/pki/tps-ui/cgi-bin/sow/cfg.pl
 #        However, RA and TPS subsystems still require their own individual
 #        ownership of this directory.
 
-%files -n dogtag-pki-common-theme
+%files -n dogtag-pki-server-theme
 %defattr(-,root,root,-)
 %doc dogtag/common-ui/LICENSE
 %dir %{_datadir}/pki
@@ -361,6 +370,10 @@ chmod 755 %{buildroot}%{_datadir}/pki/tps-ui/cgi-bin/sow/cfg.pl
 
 
 %changelog
+* Thu Nov 8 2012 Endi S. Dewata <edewata@redhat.com> 10.0.0-0.5.b2
+- Renamed dogtag-pki-common-theme to dogtag-pki-server-theme.
+- Fixed theme package dependencies.
+
 * Mon Oct 29 2012 Ade Lee <alee@redhat.com> 10.0.0-0.4.b2
 - Update release to b2
 
diff --git a/specs/dogtag-pki.spec b/specs/dogtag-pki.spec
index 3c90ff18d114a76628f4eb956a040bb91f421556..94a76339bc12ece4a7680fb295699bdfac29c5f1 100644
--- a/specs/dogtag-pki.spec
+++ b/specs/dogtag-pki.spec
@@ -8,7 +8,7 @@
 Summary:          Dogtag Public Key Infrastructure (PKI) Suite
 Name:             dogtag-pki
 Version:          10.0.0
-Release:          %{?relprefix}13%{?prerel}%{?dist}
+Release:          %{?relprefix}14%{?prerel}%{?dist}
 # The entire source code is GPLv2 except for 'pki-tps' which is LGPLv2
 License:          GPLv2 and LGPLv2
 URL:              http://pki.fedoraproject.org/
@@ -85,7 +85,7 @@ Requires:         jss-javadoc >= %{jss_version}
 # Make certain that this 'meta' package requires the latest version(s)
 # of ALL Dogtag PKI theme packages
 Requires:         dogtag-pki-ca-theme >= %{dogtag_pki_theme_version}
-Requires:         dogtag-pki-common-theme >= %{dogtag_pki_theme_version}
+Requires:         dogtag-pki-server-theme >= %{dogtag_pki_theme_version}
 Requires:         dogtag-pki-console-theme >= %{dogtag_pki_theme_version}
 Requires:         dogtag-pki-kra-theme >= %{dogtag_pki_theme_version}
 Requires:         dogtag-pki-ocsp-theme >= %{dogtag_pki_theme_version}
@@ -198,6 +198,9 @@ rm -rf %{buildroot}
 %doc README
 
 %changelog
+* Thu Nov 8 2012 Endi S. Dewata <edewata@redhat.com> 10.0.0-0.14.b2
+- Renamed dogtag-pki-common-theme to dogtag-pki-server-theme.
+
 * Mon Oct 29 2012 Ade Lee <alee@redhat.com> 10.0.0-0.13.b2
 - Update release to b2
 
diff --git a/specs/ipa-pki-theme.spec b/specs/ipa-pki-theme.spec
index cdce723ba7ef2fa339b82307f4c9e32a55b53d50..bdb15a3bdc05d02e3b79a53005df0373a6c471e2 100644
--- a/specs/ipa-pki-theme.spec
+++ b/specs/ipa-pki-theme.spec
@@ -7,7 +7,7 @@
 
 Name:             ipa-pki-theme
 Version:          10.0.0
-Release:          %{?relprefix}3%{?prerel}%{?dist}
+Release:          %{?relprefix}4%{?prerel}%{?dist}
 Summary:          Certificate System - IPA PKI Theme Components
 URL:              http://pki.fedoraproject.org/
 License:          GPLv2
@@ -52,21 +52,27 @@ for its corresponding "ipa" theme package or "dogtag" theme package.   \
 %description %{overview}
 
 
-%package -n       ipa-pki-common-theme
-Summary:          Certificate System - PKI Common Framework User Interface
+%package -n       ipa-pki-server-theme
+Summary:          Certificate System - PKI Server Framework User Interface
 Group:            System Environment/Base
 
+Conflicts:        dogtag-pki-server-theme
 Conflicts:        dogtag-pki-common-theme
 Conflicts:        dogtag-pki-common-ui
+Conflicts:        redhat-pki-server-theme
 Conflicts:        redhat-pki-common-theme
 Conflicts:        redhat-pki-common-ui
 
+Obsoletes:        ipa-pki-common-theme
+Obsoletes:        ipa-pki-common-ui
+
+Provides:         pki-server-theme = %{version}-%{release}
 Provides:         pki-common-theme = %{version}-%{release}
 Provides:         pki-common-ui = %{version}-%{release}
 
-%description -n   ipa-pki-common-theme
-This PKI Common Framework User Interface contains
-NO textual or graphical user interface for the PKI Common Framework.
+%description -n   ipa-pki-server-theme
+This PKI Server Framework User Interface contains
+NO textual or graphical user interface for the PKI Server Framework.
 
 This package is used by the Certificate System utilized by IPA.
 
@@ -77,7 +83,7 @@ This package is used by the Certificate System utilized by IPA.
 Summary:          Certificate System - Certificate Authority User Interface
 Group:            System Environment/Base
 
-Requires:         ipa-pki-common-theme = %{version}-%{release}
+Requires:         ipa-pki-server-theme = %{version}-%{release}
 
 Conflicts:        dogtag-pki-ca-theme
 Conflicts:        dogtag-pki-ca-ui
@@ -121,7 +127,7 @@ cd build
 %{__make} install DESTDIR=%{buildroot} INSTALL="install -p"
 
 
-%files -n ipa-pki-common-theme
+%files -n ipa-pki-server-theme
 %defattr(-,root,root,-)
 %doc dogtag/common-ui/LICENSE
 %dir %{_datadir}/pki
@@ -135,6 +141,9 @@ cd build
 
 
 %changelog
+* Thu Nov 8 2012 Endi S. Dewata <edewata@redhat.com> 10.0.0-0.4.b2
+- Renamed ipa-pki-common-theme to ipa-pki-server-theme.
+
 * Mon Oct 29 2012 Ade Lee <alee@redhat.com> 10.0.0-0.3.b2
 - Update release to b2
 
diff --git a/specs/pki-core.spec b/specs/pki-core.spec
index 1b6cf743d5ce6d9b37586be492a7e621b61f2ced..418890e1f02c93c718df2f7f94556c9cd164c398 100644
--- a/specs/pki-core.spec
+++ b/specs/pki-core.spec
@@ -14,7 +14,7 @@ distutils.sysconfig import get_python_lib; print(get_python_lib(1))")}
 
 Name:             pki-core
 Version:          10.0.0
-Release:          %{?relprefix}48%{?prerel}%{?dist}
+Release:          %{?relprefix}49%{?prerel}%{?dist}
 Summary:          Certificate System - PKI Core Components
 URL:              http://pki.fedoraproject.org/
 License:          GPLv2
@@ -301,7 +301,7 @@ Requires:         perl-Crypt-SSLeay
 Requires:         policycoreutils
 Requires:         openldap-clients
 Requires:         jython >= 2.2.1
-Requires:         pki-common-theme >= 10.0.0
+Requires:         pki-server-theme >= 10.0.0
 Requires:         pki-base = %{version}-%{release}
 Requires:         pki-tools = %{version}-%{release}
 
@@ -1271,6 +1271,9 @@ fi
 
 
 %changelog
+* Thu Nov 8 2012 Endi S. Dewata <edewata@redhat.com> 10.0.0-0.49.b2
+- Renamed pki-common-theme to pki-server-theme.
+
 * Mon Oct 29 2012 Ade Lee <alee@redhat.com> 10.0.0-0.48.b2
 - Update release to b2
 
-- 
1.7.12.1